function ret = ProcessImage(im, param)
    % ret is a post-processed version of im, according to param.
    % param :
    %       param.im.correlation : 0 or 1
    %       param.im.correlation_filter : correlation filter
    %       param.im.median : 0 or 1
    %       param.im.median_size : [m n] size of the median window
    %       param.im.wiener : 0 or 1
    %       param.im.wiener_size : [m n] size of the wiener window
    %
    % Author : Jean Feydy
    
    ret = im;
    if param.im.correlation
        ret = imfilter(ret, param.im.correlation_filter);
    end;
    if param.im.median
        ret = medfilt2(ret, param.im.median_size, 'symmetric');
    end;
    if param.im.wiener
        ret = wiener2(ret, param.im.wiener_size);
    end;
    
end