function [] = TestMacroscopicParameters(im, param, folder)
RES = '-r400';
FOLDER = folder;
fig = figure('Visible', 'Off');
NLINES = 1000; %4000;

% We display the processed image
param.background.image = 'processed image';
param.grad.interpolation_method = 'piecewise';
param.computeline.method = 'explicit-piecewise';

%% Figure : using transparency
clf;
param.display.line_alpha = 0.1;
param.display.scatter = 0; % No coloured points
param.mask.start.method = 'random';
param.mask.start.filter = fspecial('disk', 3) == 0;
param.mask.continue.filter = [1]; % No mask
param.n_lines = NLINES;

DispGradientLines(im, param);
set(gcf,'renderer','opengl');
title(sprintf('%d lines \n Grad processing : %s \n Line method : %s, Int. method : %s', param.n_lines, param.grad.processing_method, param.computeline.method, param.grad.interpolation_method));
print(fig, RES, '-dpng', [FOLDER sprintf('%d-transparency.png', param.n_lines)]);


%% Figure : using colour
clf;
param.display.line_alpha = 1;
param.display.scatter = 1;
param.mask.start.method = 'random';
param.mask.start.filter = fspecial('disk', 10) == 0;
param.mask.continue.filter = 0.9 * ones(11,11);
param.n_lines = NLINES;

DispGradientLines(im, param);
set(gcf,'renderer','opengl');
title(sprintf('%d lines \n Grad processing : %s \n Line method : %s, Int. method : %s', param.n_lines, param.grad.processing_method, param.computeline.method, param.grad.interpolation_method));
print(fig, RES, '-dpng', [FOLDER sprintf('%d-colour.png', param.n_lines)]);


%% Figure : Grid start
clf;
param.display.line_alpha = 1;
param.display.scatter = 1;
param.mask.start.method = 'left-top';
param.mask.start.filter = zeros(51,51);
param.mask.continue.filter = zeros(11,11);
param.n_lines = NLINES;

DispGradientLines(im, param);
set(gcf,'renderer','opengl');
title(sprintf('%d lines \n Grad processing : %s \n Line method : %s, Int. method : %s', param.n_lines, param.grad.processing_method, param.computeline.method, param.grad.interpolation_method));
print(fig, RES, '-dpng', [FOLDER sprintf('%d-colour-grid.png', param.n_lines)]);

%% Figure : Topological
clf;
param.mask.start.initialize.type = 'topological';
param.mask.start.method = 'random';
param.mask.start.filter = 0.9 * ones(11,11);
param.mask.continue.filter = zeros(3,3);
param.n_lines = NLINES;

DispGradientLines(im, param);
set(gcf,'renderer','opengl');
title(sprintf('%d lines \n Grad processing : %s \n Line method : %s, Int. method : %s', param.n_lines, param.grad.processing_method, param.computeline.method, param.grad.interpolation_method));
print(fig, RES, '-dpng', [FOLDER sprintf('%d-colour-topological.png', param.n_lines)]);

param.mask.start.initialize.type = 'ones';


end